"""
Скрипт для автоматической печати текста
в определенном окне.
Для его работы необходимо установить библиотеку pyautogui:
pip install pyautogui
"""

import subprocess
import time

import pyautogui


def lang_key_switch():
    """
    Функция определяет текущую раскладку в Linux.
    Если она не соответствует коду английской раскладки,
    автоматически ее переключает.
    """
    k_lay = subprocess.check_output("xset -q | grep -A 0 'LED' | cut -c59-67", shell=True).decode().strip()
    if k_lay == '00001006':
        pyautogui.hotkey('alt', 'shift')


def translit(text: str):
    """
    Функция выполняет замену русских букв эквивалентом
    латинских букв и символов в английской раскладке.
    В итоге получается текст в латинской раскладке,
    как если бы вы забыли ее переключить на русский.
    Это необходимо для того, чтобы pyautogui
    корректно печатал русские буквы, так как по умолчанию
    он не поддрерживает кириллицу.
    Также в функции переключается раскладка, выполняется
    транслитерация и печатается текст. Затем раскладка снова возвращается
    в прежнее состояние, то есть на английскую раскладку.
    :param text: текст для замены.
    """
    symbols = ("абвгдеёжзийклмнопрстуфхцчшщъыьэюяАБВГДЕЁЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯ",
               "f,dult`;pbqrkvyjghcnea[wxio]sm'.zF,DULT`;PBQRKVYJGHCNEA[WXIO]SM'.Z")

    tr = {ord(a): ord(b) for a, b in zip(*symbols)}
    pyautogui.hotkey('alt', 'shift')
    pyautogui.write(text.translate(tr), interval=0.1)
    pyautogui.hotkey('alt', 'shift')


def print_word():
    """
    Печатается текст в любом поле ввода с помощью функции
    write. После ввода каждой строки нажимается Enter.
    Функция сделана под PyCharm, хотя может работать в
    любой IDE, которая автоматически ставит пробелы после
    нажатия Enter. Текст печатается с заданной скорость, которая
    определяется параметром interval.
    """
    lang_key_switch()
    pyautogui.write("from pytube import YouTube", interval=0.1)
    pyautogui.press('enter')
    pyautogui.press('enter')
    pyautogui.press('enter')
    pyautogui.write("def get_keywords(url: str) -> list:", interval=0.1)
    pyautogui.press('enter')
    pyautogui.write("yt = YouTube(url)", interval=0.1)
    pyautogui.press('enter')
    pyautogui.write("return yt.keywords", interval=0.1)
    pyautogui.press('enter')
    pyautogui.press("backspace")
    pyautogui.press('enter')
    pyautogui.press('enter')
    pyautogui.press('enter')
    pyautogui.write("def main():", interval=0.1)
    pyautogui.press('enter')
    pyautogui.write("url = input('", interval=0.1)
    translit('Введите ссылку на видео')
    pyautogui.write(": ')", interval=0.1)
    pyautogui.press('enter')
    pyautogui.write("if 'youtube.com' not in url or 'playlists' in url:", interval=0.1)
    pyautogui.press('enter')
    pyautogui.write("print('")
    translit('Введите правильную ссылку')
    pyautogui.write("')", interval=0.1)
    pyautogui.press('enter')
    pyautogui.write("return ", interval=0.1)
    pyautogui.press('enter')
    pyautogui.write("kw = get_keywords(url)", interval=0.1)
    pyautogui.press('enter')
    pyautogui.write("if not kw:", interval=0.1)
    pyautogui.press('enter')
    pyautogui.write("print('\\n", interval=0.1)
    translit('В данном видео нет ключевых слов')
    pyautogui.write(":\\n')", interval=0.1)
    pyautogui.press('enter')
    pyautogui.press("backspace")
    pyautogui.write("else:")
    pyautogui.press('enter')
    pyautogui.write("print('\\n", interval=0.1)
    translit('Найдены ключевые слова')
    pyautogui.write(":\\n')", interval=0.1)
    pyautogui.press('enter')
    pyautogui.write("print('-'*23)", interval=0.1)
    pyautogui.press('enter')
    pyautogui.write("print(kw)", interval=0.1)
    pyautogui.press('enter')
    pyautogui.press('enter')
    pyautogui.press('enter')
    pyautogui.press('backspace')
    pyautogui.press('backspace')
    pyautogui.write("if __name__ == '__main__':", interval=0.1)
    pyautogui.press('enter')
    pyautogui.write("main()", interval=0.1)
    pyautogui.press('enter')


def waiter():
    """
    Запускается бесконечный цикл, в котором получаем список заголовков открытых окон.
    Сравниваем с заголовком нужного окна. Если заголовок совпадает с текстом,
    спим одну секунду и запускаем функцию печати, после чего прерываем цикл.
    """
    while True:
        command = "xprop -root _NET_ACTIVE_WINDOW | sed 's/.* //'"
        frontmost = subprocess.check_output(command, shell=True).decode("utf-8").strip()

        com_title = f'xwininfo -root -tree | grep {frontmost}'
        title = subprocess.check_output(com_title, shell=True).decode().strip().split('"')[1]
        if title == "temp – youtube_keyword.py":
            time.sleep(1)
            print_word()
            break


def main():
    """
    Запуск функции ожидания появления окна
    с определенным заголовком.
    """
    waiter()


if __name__ == "__main__":
    main()
